=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2007-02-07 03:09:58 +0000
+++ bzrlib/builtins.py	2007-02-07 03:40:37 +0000
@@ -1118,13 +1118,11 @@
     takes_args = ['location?']
     takes_options = [
                      RegistryOption('format',
-                            help='Specify a format for this branch. Current'
-                                 ' formats are: default, knit, metaweave and'
-                                 ' weave. Default is knit; metaweave and'
-                                 ' weave are deprecated',
+                            help='Specify a format for this branch. See "bzr '
+                            'help formats" for details',
                             converter=bzrdir.format_registry.make_bzrdir,
                             registry=bzrdir.format_registry,
-                            value_switches=True),
+                            value_switches=True, title="Branch Format"),
                      ]
     def run(self, location=None, format=None):
         if format is None:
@@ -1178,13 +1176,11 @@
     """
     takes_args = ["location"] 
     takes_options = [RegistryOption('format',
-                            help='Specify a format for this repository.'
-                                 ' Current formats are: default, knit,'
-                                 ' metaweave and weave. Default is knit;'
-                                 ' metaweave and weave are deprecated',
+                            help='Specify a format for this repository. See'
+                                 ' "bzr help formats" for details',
                             registry=bzrdir.format_registry,
                             converter=bzrdir.format_registry.make_bzrdir,
-                            value_switches=True),
+                            value_switches=True, title='Repository format'),
                      Option('trees',
                              help='Allows branches in repository to have'
                              ' a working tree')]
@@ -2002,13 +1998,11 @@
     takes_args = ['url?']
     takes_options = [
                     RegistryOption('format',
-                        help='Upgrade to a specific format. Current formats'
-                             ' are: default, knit, metaweave and weave.'
-                             ' Default is knit; metaweave and weave are'
-                             ' deprecated',
+                        help='Upgrade to a specific format.  See "bzr help'
+                             ' formats" for details',
                         registry=bzrdir.format_registry,
                         converter=bzrdir.format_registry.make_bzrdir,
-                        value_switches=True),
+                        value_switches=True, title='Branch format'),
                     ]
 
 

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2007-01-17 19:43:23 +0000
+++ bzrlib/option.py	2007-02-07 03:40:37 +0000
@@ -226,7 +226,7 @@
             return self.converter(value)
 
     def __init__(self, name, help, registry, converter=None,
-        value_switches=False):
+        value_switches=False, title=None):
         """
         Constructor.
 
@@ -244,9 +244,14 @@
         self.name = name
         self.converter = converter
         self.value_switches = value_switches
+        self.title = title
+        if self.title is None:
+            self.title = name
 
     def add_option(self, parser, short_name):
         """Add this option to an Optparse parser"""
+        if self.value_switches:
+            parser = parser.add_option_group(self.title)
         Option.add_option(self, parser, short_name)
         if self.value_switches:
             for key in self.registry.keys():

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2007-01-26 22:15:58 +0000
+++ bzrlib/tests/test_options.py	2007-02-07 03:40:37 +0000
@@ -170,11 +170,12 @@
         registry.register_metadir('two', 'RepositoryFormatKnit1', 'two help')
         registry.set_default('one')
         options = [option.RegistryOption('format', 'format help', registry,
-                   str, value_switches=True)]
+                   str, value_switches=True, title='Formats')]
         parser = option.get_optparser(dict((o.name, o) for o in options))
         value = parser.format_option_help()
         self.assertContainsRe(value, 'format.*format help')
         self.assertContainsRe(value, 'one.*one help')
+        self.assertContainsRe(value, 'Formats:\n *--format')
 
     def test_iter_switches(self):
         opt = option.Option('hello', help='fg')

